#/bin/sh
# Threshold plugin 2.1c for cacti 8.6c
#
# Copyright 2005 Aurelio DeSimone
# adesimone@ciscoconfigbuilder.com
# 
# Use at your own risk.  NO Warranty or Guarantee given.
#
# Some code may have been used from other parts of cacti - copyright of Ian Berry
#

#define some stuff
if [ "$1" != "" ]
        then
                if [ -f "$1/poller.php" ]
                        then
                        echo "Directory Check OK"
                else
                        echo "Cacti 8.6c not found.  Please check syntax"
                        exit
                fi
                echo "Installing into $1"
        else
                echo "Error - wrong syntax - you must specify cacti root directory ie: install.sh /var/www/html/cacti"
                exit
fi


# make sure we aren't installing twice
checkold=`grep -i thold $1/* | grep -v zip | wc -l | awk '{print $1}'`

if [ $checkold -eq 0 ]
	then
		echo "This is a new install.."
	else
		echo "An installation seems already be present."
		echo "This version is not back-ward compatible."
		echo "WARNING: If you proceed, all old thold settings will be erased."
		echo -n "Do you want to continue (y/n):"
		read var1
		var2="y"
		if [ "$var1" == "$var2" ]
			then
				echo "Overwriting existing install..."
		else
			exit
		fi
		
fi




cactibasedir=$1

lookup=$cactibasedir/include/config.php

cactidbname=`grep database_default $lookup | awk -F '"' '{print $2}'`
database_username=`grep database_username $lookup | awk -F '"' '{print $2}'`
database_password=`grep database_password $lookup | awk -F '"' '{print $2}'`

#mysql check
echo "show tables;" > quit.txt
checkdbconn=`mysql $cactidbname --user=$database_username --password=$database_password  < quit.txt | grep host_template_snmp_query | wc -l | awk '{print $1}'`
if [ $checkdbconn -eq 1 ]
        then
                echo "DB login OK"
        else
                if [ "$2" == "" ]
                        then
                                echo "Database login failed.  Please specify cacti database login - i.e. install.sh /var/www/html/cacti cactiuer cactipass"
				exit
                        else
                                echo "database username and pass given"
                                checkdbagain=`mysql $cactidbname --user=$2 --password=$3 < quit.txt | grep host_template_snmp_query | wc -l | awk '{print $1}'`
                                if [ $checkdbagain -eq 1 ]
                                        then
                                                echo "DB login OK"
						database_username=$2
						database_password=$3
                                        else
						echo "**************************************************************"
                                                echo "WARNING: - Database login still failed - "
                                                echo "You will have to import manually using 'mysql cacti < thold.sql"
						echo "**************************************************************"
                                fi
                fi
fi
rm -rf quit.txt

echo " "
echo "WARNING: you may want to backup files & cacti database before proceeding."
echo "An uninstall script is provided to remove & restore modified files."
echo "Use at your own risk.  NO Warranty or Guarantee given."
echo "If you continue, you agree not to hold me liable for damages or loss of data."
echo "press CTRL+C in the next 5 seconds to stop"
sleep 6
echo " "

# backup first
echo "Backing up files..."
cp $cactibasedir/graphs_new.php $cactibasedir/graphs_new.php.bak
cp $cactibasedir/data_sources.php $cactibasedir/data_sources.php.bak
cp $cactibasedir/lib/functions.php $cactibasedir/lib/functions.php.bak
cp $cactibasedir/include/config_arrays.php $cactibasedir/include/config_arrays.php.bak
cp $cactibasedir/include/config_settings.php $cactibasedir/include/config_settings.php.bak
cp $cactibasedir/include/top_header.php $cactibasedir/include/top_header.php.bak
cp $cactibasedir/include/top_graph_header.php $cactibasedir/include/top_graph_header.php.bak
mysqldump $cactidbname --user=$database_username --password=$database_password > $cactibasedir/cacti_pre_thold2.1a.backup.sql

# add table
echo "Adding SQL tables..."

mysql $cactidbname --user=$database_username --password=$database_password < thold.sql
#rm -rf thold.sql

# install files
echo "Installing new files..."
mkdir $cactibasedir/thold/
touch $cactibasedir/log/thold.log

mv check-thold.php $cactibasedir/thold/
mv thold.php $cactibasedir/
mv listthold.php $cactibasedir/
mv tab_thold.gif $cactibasedir/images/
mv graph_thold.php $cactibasedir/
mv config_arrays.php $cactibasedir/include/
mv config_settings.php $cactibasedir/include/
mv data_sources.php $cactibasedir/
mv graphs_new.php $cactibasedir/
mv functions.php $cactibasedir/lib/
mv top_graph_header.php $cactibasedir/include/
mv top_header.php $cactibasedir/include/
mv thold-functions.php $cactibasedir/lib/



echo "*************************************************************************************************** "
echo "Installation complete.  MAKE SURE YOU MODIFY YOUR CRONTAB (crontab -e on most systems):"
echo " "
echo "Replace the line:"
echo "*/5 * * * * php $1/poller.php > /dev/null > /dev/null 2>&1"
echo "With:"
echo "*/5 * * * * php $1/poller.php >/dev/null 2>&1 && php $1/thold/check-thold.php > /dev/null 2>&1"
echo "**************************************************************************************************** "
